* Shared problems are solved faster
* Transparency forces authenticity and honesty
* Participative communities are more open to change
* Open standards provide business agility
* With more eyes, all typos are shallow
* [Jon Prall](http://jprall.typepad.com/blog/2010/10/85-operational-rules.html) - (2007) 85 Operations Rules to Live By
* Make decisions using the path of least regret
* The simplest explanation is always the most likely.
* [Christopher Diggins](http://www.artima.com/weblogs/viewpost.jsp?thread=331531) - The Principles of Good Programming
* You are the books you read, the films you watch, the music you listen to, the people you spend time with, the conversations you engage in. Choose wisely what you feed your mind.
* [Lars Kappert](https://webpro.github.io/programming-principles/) - Categorized Overview of Programming Principles
* [Lucas Medeiros Reis](https://dev.to/iamlucasmreis/the-single-most-important-driver-of-software-quality) - The Single Most Important Driver Of Software Quality
  * don't change code you don't understand
  * never merge a branch with known defects
  * use checklists to make sure the whole problem is solved
  * static analysis tools for everything
  * code review for everything
  * test (automated and manual)
  * make small changes and iterate
* [Ozan Onay](https://blog.bradfieldcs.com/you-are-not-google-84912cf44afb) - You Are Not Google
  * Don’t even start considering solutions until you **Understand** the problem. Your goal should be to “solve” the problem mostly within the problem domain, not the solution domain.
  * **eNumerate** multiple candidate solutions. Don’t just start prodding at your favorite!
  * Consider a candidate solution, then read the **Paper** if there is one.
  * Determine the **Historical context** in which the candidate solution was designed or developed.
  * Weigh **Advantages** against disadvantages. Determine what was de-prioritized to achieve what was prioritized.
  * **Think!** Soberly and humbly ponder how well this solution fits your problem. What fact would need to be different for you to change your mind? For instance, how much smaller would the data need to be before you’d elect not to use Hadoop?
* [Viktor Farcic](cd/viktor_farcic_on_continuous_delivery.md) - Jenkins World 2017: The Ten Commandments Of Continuous Delivery
* do pull requests
* prioritize
* finish what you're doing, focus on a small number of tasks in parallel. 
* delegate some work to others if you already have lot of work to achieve, so you have more time to work on what matters for you
* [O'reilly](http://programmer.97things.oreilly.com/wiki/index.php/Contributions_Appearing_in_the_Book) - contributions appearing in book 97 Things Every Programmer Should Know
* [Daniel Miessler](https://danielmiessler.com/projects/concepts/) - Lot of concepts summarized by Daniel Miessler
* [Kent Beck](https://twitter.com/KentBeck/statuses/499584833929367552) - If you break a problem into sub-problems and the sub-problems aren't simpler than the original problem, git reset --hard and try again
* [Stuart Sierra](https://twitter.com/stuartsierra/statuses/512009723282206722) - There's always a reason, no matter how strange the bug
* [Johannes Seitz](https://twitter.com/Ookami86/statuses/515483645663252480) - Software Engineering best practice: Actually understand what you’re doing. Unfortunately it’s rarely used in practice.
* [Stuart Sierra](https://twitter.com/stuartsierra/statuses/516967544167489536) - "Bugs are dependency-transitive"
* [Stuart Halloway](https://twitter.com/stuarthalloway/statuses/502906568569286657) - the #1 source of software defects is easy presumtion. Presume nothing.
* "The Principle of Least Astonishment: Make a user interface as consistent and as predictable as possible"
* "Worried that TDD will slow down your programmers? Don't. They probably need slowing down." [J. B. Rainsberger](https://twitter.com/jbrains/statuses/167297606698008576)
* encourage others when they need it. [relevant reference](https://imgur.com/gallery/ihRohVQ)
* [Tim Lister](https://twitter.com/abt_programming/statuses/538015028574945280) - If you don't get innate pleasure from writing code, it's time to move on
* [Raphaël Yharrassarry](https://twitter.com/QuentinG/status/532974296269062144/photo/1) - Il faut s'attaquer aux comportements et non aux idées
* [Natanael Copa](https://www.youtube.com/watch?v=5FHYdwQlAMs) - don't install / start things unless explicitly asked for or needed (to improve security)
* [Paul Graham](https://twitter.com/ValaAfshar/statuses/538015468146393088) - Don't let other people tell you the problems you're working on don't matter. People are frequently mistaken about this.
* [Meir Lehman](https://twitter.com/CodeWisdom/status/921139649661284352) - An evolving system increases its complexity unless work is done to reduce it.
* [Vala Afshar](https://twitter.com/ValaAfshar/statuses/537441340842582017) - Tell people where you're going and why. Some may volunteer their time and effort to help you get there sooner.
* [Goethe](https://twitter.com/ValaAfshar/statuses/537084241268727808) - The way you see people is the way you treat them, and the way you treat them is what they become.
* [Amelia Earhart](https://twitter.com/GlenGilmore/statuses/536974002557042689) - The most effective way to do it, is to do it. ~ Amelia Earhart RT 
* [Vala Afshar](https://twitter.com/ValaAfshar/statuses/536662076924915712) - The best way to achieve mediocrity is by often choosing the path of least resistance.
* [Roy Osing](https://talentculture.com/11-ways-to-lose-yourself-in-the-crowd/) - Anti principles (Don't do this !) / 11 Ways To Lose Yourself In The Crowd
* [Martin Fowler](https://twitter.com/abt_programming/statuses/531036428948738048) - When you feel the need to write a comment, first try to refactor the code so that any comment becomes superflouus 
* [Craig Zerouni](https://twitter.com/abt_programming/statuses/548978665221267458) - "If you have too many special cases, you are doing it wrong"
* You learn nothing from life if you think you're right all the time
* Mark Twain : If you tell the truth, you don't have to remember anything. 
* One day, you will be at the place you always wanted to be. Don't stop believing.
* There is no elevator to success. You have to take the stairs.
* [Andy Hunt & Dave Thomas](https://twitter.com/nicolopigna/status/921280768697143296) - the original DRY principle : "Every piece of knowledge must have a single, unambiguous, authoritative representation, within a system"
* A prototype is worth a thousand meetings
* Business software implementation and development is unpredictable. There will always be things to alter timeline and priorities. [Tina Marie Parker](https://twitter.com/Nozeyparkers/status/922403525950353409)
* As a developer you should strive to at least understand one level of abstraction deeper than you work on - [Scott Davis](https://twitter.com/danielbryantuk/status/919866216222724096)
* [DhilipSiva Bijju](http://dhilipsiva.blogspot.be/2013/06/best-practices.html) - (2013) some Best Practices. **Bonus** : [Related GitHub repo](https://github.com/dhilipsiva/best-practices)
* Keep your code absolutely simple. Keep looking at your functions and figure out how you simplify further - [John Romero](https://twitter.com/CodeWisdom/status/926568192729894912)
* Fix it immediately, but plan for the future fix. Document the fix. Automate the solution. [Adam Bertram](https://www.pluralsight.com/blog/it-ops/troubleshooting-tips)
* Finding errors in your past decisions and ideas means you’re progressing. - [Greg Kogan](https://www.gkogan.co/blog/progression/)
* You can’t go fast when everyone is spending their time fighting with the poor decisions of yesterday - [Adam Chester](https://twitter.com/adamchester/status/925479016798109696)
* Better to Say "Oops" Than "What If…" (= avoid analysis-paralysis, or paralysis by analysis, aka the state of over-analyzing / over-thinking)
* The Art Of Clean Code by [Victor Rentea](https://www.youtube.com/watch?v=J4OIo4T7I_E)
  * Make it more readable even if it makes writing harder : We read 10x more times than we write
  * Boy scout rule : always check in code cleaner than you found it
  * Functions are verbs
  * Boolean names should always answer yes/no
  * Classes are nouns. Avoid meaningless names (OrderInfo, OrderData vs Order)
  * Delete the interfaces : except for Remoting/API client jars and strategy pattern implementation.
  * Names : Make the name speak for itself. Apply Continuous renaming as your learn the application
  * Names : Names should be at least pronounceable. Don't abbreviate ! Unless it's a basic business concept, like VAT
  * Names : should be consistent and unique (synonyms confuse). 
  * Names should have meaningful context. eg: order.customerFirstName. But don't repeat yourself (DRY) : Order.~~order~~CreationDate
  * Functions should be small : 5-10 lines, ... or at least should be understandable in 5 sec no more.
  * Functions do one thing
  * Functions have max 2-3 parameters
* [Shirky Principle](https://twitter.com/OlafLewitz/statuses/560711454434025472) : Institutions will try to preserve the problem to which they are the solution.
* [Shower Thoughts](https://twitter.com/TheWeirdWorld/status/930155807651528706) - Don’t forget to drink water, get sunlight, and that we are basically a house plant with complicated feelings.
* [David McRaney](https://youarenotsosmart.com/2010/06/23/confirmation-bias/) - Confirmation Bias : Your opinions are the result of years of paying attention to information which confirmed what you believed while ignoring information which challenged your preconceived notions.
* [David McRaney](https://youarenotsosmart.com/2013/05/23/survivorship-bias/) - Survivorship Bias : When failure becomes invisible, the difference between failure and success may also become invisible.
* [David McRaney](https://youarenotsosmart.com/2010/10/27/procrastination/) - Procrastination is fueled by weakness in the face of impulse and a failure to think about thinking.
* [David McRaney](https://youarenotsosmart.com/2010/05/19/fanboyism-and-brand-loyalty/) - Fanboyism and Brand Loyalty : You prefer the things you own because you rationalize your past choices to protect your sense of self. The Internet changed the way people argue.
* Backend Engineer Principles by [Kim Hirokuni](http://kimh.github.io/blog/being-backend-engineer/)
  * Security First : Risks have to be measured by the impact when that happens, not how likely it happens
  * Don’t break stuff : Backward compatibility for the win
  * Don’t merge PRs at late night : Merging PRs at Friday night is a terrible thing to do  

## personal thoughts
* [MorganGeek](https://twitter.com/MorganGeek/statuses/420907517934178304) - Problem solving / Productivity : Good programmers write code after they found the solution. Un bon programmeur ne commence à coder qu'après avoir trouvé une solution.
* [MorganGeek](https://twitter.com/MorganGeek/statuses/450614047608934400) - Productivity : To find a solution, first eliminate the impossible ones. Astuce : Trouver la solution en éliminant d'abord les non solutions.
* [MorganGeek](https://twitter.com/MorganGeek/statuses/450218285129531392) - Readability / Reusability : If you wan write a 100 lines function, you can also replace it with a dozen more legible functions

## Values I adhere to 
* Learn the basics of a language before learning frameworks
* DRY (Don't Repeat Yourself) is not about code, but about knowledge
* Refactoring is a development technique, not a project
* Break rules, take risks.
* True leaders want everybody to be great.
* True leaders don't respect discipline.
* Build and grown trust otherwise it can't work
* Best way to convince is by giving an example / by showing it exists
* Everything we do expresses a need
* We often eat only what we already like / know
* We all criticize, we need to be aware of it
* Violence is an answer to unsatisfied needs
* Take pleasure in simple things
* Ban negative thoughts
* Take the time you need, don't go too fast
* Take risks 
* Ask for help when struggling
* Don't do to others what you don't want done to you
* Write down your ideas and your Aha moments
* Share your feelings, don't hide your humanity 
* Don't let other people decide your future for you
* Give your word. 
* Say no rather than "I don't know" or "whatever you wish"
* Doing / saying nothing is already telling something
* Let go of control / release the need to control
* The faster you do a task the more you learn and the sooner you become satisfied
* The slower you do a task the more painful it will be
* Say thanks
* Smile
* Give, share
* Take time for you, for important things and people
* Keep in touch, maintain friendship
* Market yourself. You're putting on the effort, make sure you show it
* Go right to the point
* Ask why
* Keep your ability to be amazed by things and people, they won't last forever
* Act to fight perfectionism
* Take advantage of any opportunities that present themselves
* Physical and visual contact rather than emails, sms, chat
* Accept people as they are
* Select your friends
* More slow, minder stress
* Remain calm and quiet about everything which you will experience
* Reinvent yourself, evolve
* Grow and progress in love, work, leisure
* Be yourself, know yourself
* Be curious, observe and play (mentally, physically) with what surrounds you
* Be positive
* Be realistic, concrete
* Understand your goals and others' goals
* Taking notes, writing things down is a way to free your mind and not forget or lose anything. It's also a way to train your senses of observation and reflection
* Observe without judging, relate facts
* Choose the right tool for the job
* Don't multitask
* Achieve what you're doing before you move to something else
* Life doesn't get easier you just get stronger
* living isn't fucking easy but at least you can make your life more fun
* when you pause what you're doing, you find more interesting ways to do it. So pause often
* Be you ! the world will adjust
* Write simple code that does not need to be refactored immediately : build solutions that can still be used or adapted to tomorrow needs
* Build solutions for today but anticipate future changes and always be at least one step ahead

## Art of Questions
* Just ask
* Explain your misunderstanding 
* Explain / state what you know / don't know
* Sound confident
* Have a come back
* Know first which answer type you're expecting : Opinion ? Factually correct answer ? Well reasoned judgment ? 
* Avoid "yes" or "no" questions 
* Dig deeper (5 Why...)
* Use the power of silence
* Don't interrupt
* Prepare the topic (know a bit what you are talking about)
* Check your assumptions (are you sure about what you think you know ?)
* Find the right person to ask
* Use correct grammar
* Keep the question simple
* Differenciate between open (Why ?) vs closed (when ? who ?) question types
* Explain why you are asking 

## Art of Communication
* Never use "never", always avoid "always"
* Suggest, don't criticize
* Don't make important decisions alone
* Don't cut communication, don't go away, don't flee
* Share your needs, your wills, your tastes / opinions
* Mutually listen to each other. Know how to listen. Use your right ear for listening (right ear = left brain) 
* Feedback is important : Show interest (nod, smile, ...)
* Talk about the connection you have with the other person
* When you communicate a hard decision, don't hide behind emails, talk directly to your audience
* Use the [SBI tool](https://www.mindtools.com/pages/article/situation-behavior-impact-feedback.htm) (Situation - Behavior - Impact)
* Assertiveness is ability to say yes to the person, no to the task 
* Respond rather than react
* Prepare, verify carefully what you will communicate
* Check if your message has been heard and understood
* Expect / Give feedback 
* Know the 7 C's : Clear Concise Concrete Correct Coherent Complete Courteous 
* Set the main idea first
* Focus on your audience
* Avoid passive constructions
* Be open minded, don't think you know eveything about your audience
* Use the body language (physical and visual contact, ...)
* Stay calm : Wrap up then stop talking. Pause. Repeat. Ask clarification of a statement. Be clear. 
* Look for humor. 
* Look for compromise if the other cares about something not important for you 
* Agree to disagree : take beak so everyone calms down 
* Assert yourself : express (negative) opinions and needs positively. Ask for help. Learn from errors. Accept feedback. Say no
* Observe rather than interpret. Communicate facts not interpretations
* Understand people's needs/feelings
* Use non violent communication 
